#pragma once

#include "componentbasic.h"
#include <messagebasic.h>

/// <summary>
/// Ϊʵڵ
/// </summary>
class COMPONENTBASIC_EXPORT MapHost : public Serializable {
private:
	/// <summary>
	/// {Topicinit-value}
	/// </summary>
	QHash<QString, std::shared_ptr<TopicData>> _variable_types;
	/// <summary>
	/// 
	/// </summary>
	QHash<QString, std::shared_ptr<TopicData>> _variable_map;

public:
	virtual ~MapHost() = default;
	/// <summary>
	/// ע
	/// </summary>
	/// <param name="init"></param>
	virtual void registData(std::shared_ptr<TopicData> init) = 0;
	/// <summary>
	/// ñʹ׳UniException쳣
	/// ڵʼʱᰴעĬֵ
	/// </summary>
	virtual void setVariable(const QString& key, std::shared_ptr<TopicData> ins);
	/// <summary>
	/// ȡָƵݱ
	/// </summary>
	/// <param name="key"></param>
	/// <returns>ָݣnullptrͲȷ</returns>
	virtual std::shared_ptr<TopicData> getVariable(const QString& key) const;
};

/// <summary>
/// ߼ڵĻ
/// </summary>
class LogicalNode : public Serializable {
public:
	virtual ~LogicalNode() = default;

	/// <summary>
	/// ýڵid
	/// </summary>
	/// <param name="unique_id"></param>
	virtual void setID(int unique_id) = 0;
	/// <summary>
	/// ȡڵid
	/// </summary>
	/// <returns></returns>
	virtual int getID() const = 0;
	/// <summary>
	/// ȡڵ
	/// </summary>
	/// <returns></returns>
	virtual QString name() const = 0;

	/// <summary>
	/// ȡӽڵб
	/// </summary>
	/// <returns></returns>
	virtual QList<std::shared_ptr<LogicalNode>> children() const = 0;

	/// <summary>
	/// ڲʶݽӿ
	/// </summary>
	/// <returns>map{name, type}</returns>
	virtual QHash<QString, std::shared_ptr<TopicData>> inputDeclares() const = 0;
	/// <summary>
	/// ڲʶݽӿ
	/// </summary>
	/// <returns>map{name, type}</returns>
	virtual QHash<QString, std::shared_ptr<TopicData>> outputDeclares() const = 0;
};

/// <summary>
/// ԶΪڵʵ
/// </summary>
class COMPONENTBASIC_EXPORT BehaviorMapNode : public MapHost, public LogicalNode {
public:
	/// <summary>
	/// Ϊļ
	/// </summary>
	/// <param name="path"></param>
	virtual void setBehaviorMap(const QString &path){}
	/// <summary>
	/// Ϊڵ
	/// </summary>
	/// <param name="val"></param>
	virtual void resetName(const QString &val){}
};

/// <summary>
/// Ϊ
/// </summary>
class COMPONENTBASIC_EXPORT BehaviorPerformPlugin : public ProcList<
	WsRespond<SyncRequest, RespondDefault>
>{
private:
	std::weak_ptr<WsEntity> _bind_entity;

public:
	// ͨ ProcList ̳
	void execute(std::shared_ptr<Immediate> map, std::shared_ptr<const SyncRequest> in, QList<std::shared_ptr<RespondDefault>>& out) override;

	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;

	std::shared_ptr<WsComponent> defaultNew() const override;
	void bindEntity(std::weak_ptr<WsEntity> host) override;
	QString name() const override;
};

